## sink-0.9.0-1.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0028 NEW)
cmake_policy(SET CMP0063 NEW)

project(sink VERSION 0.9.0)

option(BUILD_MAILDIR "BUILD_MAILDIR" ON)
option(BUILD_DAV "BUILD_DAV" ON)
option(CATCH_ERRORS "CATCH_ERRORS" OFF)
option(ENABLE_MEMCHECK "Build valgrind tests" OFF)
option(ENABLE_ASAN "Enable the address sanitizer" OFF)
option(ENABLE_TSAN "Enable the thread sanitizer" OFF)
option(ENABLE_TIDY "Enable the static code analyzer" OFF)

# ECM setup
find_package(ECM 5.29.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH
        ${ECM_MODULE_PATH}
        ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
        ${CMAKE_CURRENT_SOURCE_DIR}/tests
        ${CMAKE_MODULE_PATH})

include(FeatureSummary)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(KDEInstallDirs)
#Avoid building appstreamtest
set(KDE_SKIP_TEST_SETTINGS true)
#Pick up rpath settings
include(KDECMakeSettings NO_POLICY_SCOPE)
#We only have console applications here
set(CMAKE_MACOSX_BUNDLE OFF)
set(CMAKE_WIN32_EXECUTABLE OFF)

ecm_setup_version(PROJECT
                  SOVERSION sink_VERSION_MAJOR
                  VERSION_HEADER sink_version.h
                  )

find_package(Qt5 COMPONENTS REQUIRED Core Concurrent Network Gui Test)
find_package(KF5 COMPONENTS REQUIRED Mime Contacts CalendarCore)
find_package(FlatBuffers REQUIRED 1.4.0)
find_package(KAsync REQUIRED 0.3)
find_package(LMDB REQUIRED 0.9)
find_package(Xapian REQUIRED 1.4)
find_package(Gpgme REQUIRED)

if (${ENABLE_MEMCHECK})
    message("Enabled memcheck")
    find_program(MEMORYCHECK_COMMAND valgrind)
    if(NOT MEMORYCHECK_COMMAND)
        message(FATAL_ERROR "valgrind not found!")
    endif()
    set(MEMORYCHECK_COMMAND_OPTIONS "--trace-children=yes --leak-check=full")
endif()

if (${ENABLE_ASAN})
    message("Enabled ASAN")
    set(SINK_ASAN_FLAG "-fsanitize=address -fPIE -fno-omit-frame-pointer -O1 ")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${SINK_ASAN_FLAG}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SINK_ASAN_FLAG}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${SINK_ASAN_FLAG}")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${SINK_ASAN_FLAG}")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${SINK_ASAN_FLAG}")
endif()

if (${ENABLE_TSAN})
    message("Enabled TSAN")
    set(SINK_TSAN_FLAG "-fsanitize=thread -fPIE -fno-omit-frame-pointer -O1 ")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${SINK_TSAN_FLAG}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SINK_TSAN_FLAG}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${SINK_TSAN_FLAG}")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${SINK_TSAN_FLAG}")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${SINK_TSAN_FLAG}")
endif()

if (${ENABLE_TIDY})
    find_program(
        CLANG_TIDY
        NAMES "clang-tidy"
        DOC "Path to clang-tidy executable"
    )
    set(CMAKE_CXX_CLANG_TIDY ${CLANG_TIDY} -checks=-*,modernize-use-override -fix --fix-errors)
endif()


#Clang-format support
add_custom_command(
    OUTPUT  format.dummy
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND clang-format -i ${CMAKE_SOURCE_DIR}/**.{cpp,h}
)
add_custom_target(format DEPENDS format.dummy)

function(generate_flatbuffers _target)
    foreach(fbs ${ARGN})
        #Necessary because we can get relative paths as name, e.g. commands/create_entity
        get_filename_component(filename ${fbs} NAME)
        #We first generate into a temporary directory to avoid changing the timestamp of the actual dependency unnecessarily.
        #Otherwise we'd end up unnecessarily rebuilding the target.
        add_custom_command(
            OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${fbs}_generated.h
            COMMAND ${FLATBUFFERS_FLATC_EXECUTABLE} -c -b -o ${CMAKE_CURRENT_BINARY_DIR}/flatbufferstmp ${CMAKE_CURRENT_SOURCE_DIR}/${fbs}.fbs
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                ${CMAKE_CURRENT_BINARY_DIR}/flatbufferstmp/${filename}_generated.h
                ${CMAKE_CURRENT_BINARY_DIR}/${filename}_generated.h
            DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${fbs}.fbs

        )
        target_sources(${_target} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/${fbs}_generated.h)
        set_property(SOURCE ${fbs}_generated.h PROPERTY SKIP_AUTOMOC ON)
    endforeach(fbs)
endfunction(generate_flatbuffers)


set(CMAKE_AUTOMOC ON)
if (${CATCH_ERRORS})
    add_definitions("-Werror -Wall -Weverything -Wno-unused-function -Wno-cast-align -Wno-used-but-marked-unused -Wno-shadow -Wno-weak-vtables -Wno-global-constructors -Wno-deprecated -Wno-weak-template-vtables -Wno-exit-time-destructors -Wno-covered-switch-default -Wno-shorten-64-to-32 -Wno-documentation -Wno-old-style-cast -Wno-extra-semi -Wno-unused-parameter -Wno-c++98-compat -Wno-c++98-compat-pedantic -Wno-padded -Wno-missing-noreturn -Wno-missing-prototypes -Wno-documentation-unknown-command -Wno-sign-conversion -Wno-gnu-zero-variadic-macro-arguments -Wno-disabled-macro-expansion -Wno-vla-extension -Wno-vla -Wno-undefined-func-template -Wno-#warnings -Wno-unused-template -Wno-inconsistent-missing-destructor-override -Wno-zero-as-null-pointer-constant -Wno-unused-lambda-capture -Wno-switch-enum -Wno-redundant-parens -Wno-extra-semi-stmt -Wno-suggest-destructor-override")
endif()

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if (MSVC)
    # Workaround for older cmake versions
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /std:c++20")
    # We get way to many warnings for this
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-nonportable-include-path")
endif()

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${FLATBUFFERS_INCLUDE_DIR} ${CMAKE_BINARY_DIR}/common 3rdparty)
include_directories(SYSTEM ${CMAKE_SOURCE_DIR}/common ${CMAKE_SOURCE_DIR}/common/domain ${CMAKE_SOURCE_DIR}/mime)

configure_file(hawd.conf hawd.conf)

enable_testing()

set(SINK_RESOURCE_PLUGINS_PATH ${QT_PLUGIN_INSTALL_DIR}/sink/resources)

# mime support
add_subdirectory(mime)

# common, eventually a lib but right now just the command buffers
add_subdirectory(common)

# the synchronizer
add_subdirectory(synchronizer)

# example implementations
add_subdirectory(examples)

# some tests
add_subdirectory(tests)

# cli
add_subdirectory(sinksh)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== common/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(domain)

ecm_setup_version(${sink_VERSION}
    VARIABLE_PREFIX Sink
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/sink_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/SinkConfigVersion.cmake"
    SOVERSION 0
)

########### CMake Config Files ###########
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/Sink")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/SinkConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/SinkConfig.cmake"
    INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/SinkConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/SinkConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

set(CMAKE_CXX_VISIBILITY_PRESET default)

install(EXPORT SinkTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE SinkTargets.cmake)

add_library(${PROJECT_NAME} SHARED
    store.cpp
    secretstore.cpp
    notifier.cpp
    resourcecontrol.cpp
    modelresult.cpp
    definitions.cpp
    log.cpp
    entitybuffer.cpp
    facadefactory.cpp
    commands.cpp
    facade.cpp
    pipeline.cpp
    propertymapper.cpp
    domainadaptor.cpp
    resource.cpp
    genericresource.cpp
    resourceaccess.cpp
    queryrunner.cpp
    listener.cpp
    storage_common.cpp
    threadboundary.cpp
    messagequeue.cpp
    index.cpp
    typeindex.cpp
    resourcefacade.cpp
    resourceconfig.cpp
    configstore.cpp
    resultset.cpp
    domain/propertyregistry.cpp
    domain/applicationdomaintype.cpp
    domain/typeimplementations.cpp
    test.cpp
    query.cpp
    changereplay.cpp
    adaptorfactoryregistry.cpp
    synchronizer.cpp
    synchronizerstore.cpp
    contactpreprocessor.cpp
    mailpreprocessor.cpp
    eventpreprocessor.cpp
    todopreprocessor.cpp
    specialpurposepreprocessor.cpp
    datastorequery.cpp
    storage/entitystore.cpp
    storage/key.cpp
    indexer.cpp
    mail/threadindexer.cpp
    mail/fulltextindexer.cpp
    notification.cpp
    commandprocessor.cpp
    inspector.cpp
    propertyparser.cpp
    utils.cpp
    fulltextindex.cpp
    storage_lmdb.cpp)


generate_flatbuffers(
    ${PROJECT_NAME}

    commands/commandcompletion
    commands/createentity
    commands/deleteentity
    commands/handshake
    commands/modifyentity
    commands/revisionupdate
    commands/synchronize
    commands/notification
    commands/revisionreplayed
    commands/inspection
    commands/flush
    commands/secret
    domain/contact
    domain/addressbook
    domain/event
    domain/todo
    domain/calendar
    domain/mail
    domain/folder
    domain/dummy
    entity
    metadata
    queuedcommand
)

generate_export_header(${PROJECT_NAME} BASE_NAME Sink EXPORT_FILE_NAME sink_export.h)
SET_TARGET_PROPERTIES(${PROJECT_NAME}
    PROPERTIES LINKER_LANGUAGE CXX
    VERSION ${Sink_VERSION}
    SOVERSION ${Sink_SOVERSION}
    EXPORT_NAME ${PROJECT_NAME}
)

target_link_libraries(${PROJECT_NAME}
PUBLIC
    KAsync
    Qt5::Network
PRIVATE
    ${LMDB_LIBRARIES}
    Qt5::Gui
    KF5::Mime
    KF5::Contacts
    KF5::CalendarCore
    ${XAPIAN_LIBRARIES}
    sink_mimetreeparser
)
install(TARGETS ${PROJECT_NAME}
    EXPORT SinkTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} ${LIBRARY_NAMELINK} )

install(FILES
    store.h
    notifier.h
    resourcecontrol.h
    domain/applicationdomaintype.h
    query.h
    standardqueries.h
    inspection.h
    notification.h
    bufferadaptor.h
    test.h
    log.h
    flush.h
    secretstore.h
    ${CMAKE_CURRENT_BINARY_DIR}/sink_export.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME} COMPONENT Devel
)

=== mime/CMakeLists.txt ===
include_directories(. ${GPGME_INCLUDE_DIRS})

add_library(crypto STATIC
    crypto.cpp
)
target_link_libraries(crypto
    PUBLIC
    Qt5::Core
    Gpgme::Gpgme
)

install(FILES
    crypto.h
    errors.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/sink COMPONENT Devel
)

add_subdirectory(mimetreeparser)

=== sinksh/CMakeLists.txt ===
project(sinksh)

set(sink_cli_SRCS
    main.cpp
    syntaxtree.cpp
    syntax_modules/core_syntax.cpp
    syntax_modules/sink_list.cpp
    syntax_modules/sink_clear.cpp
    syntax_modules/sink_count.cpp
    syntax_modules/sink_create.cpp
    syntax_modules/sink_modify.cpp
    syntax_modules/sink_remove.cpp
    syntax_modules/sink_stat.cpp
    syntax_modules/sink_sync.cpp
    syntax_modules/sink_trace.cpp
    syntax_modules/sink_inspect.cpp
    syntax_modules/sink_drop.cpp
    syntax_modules/sink_upgrade.cpp
    syntax_modules/sink_info.cpp
    syntax_modules/sink_livequery.cpp
    syntax_modules/sink_selftest.cpp
    syntax_modules/sink_connectiontest.cpp
    syntax_modules/sink_monitor.cpp
    sinksh_utils.cpp
    repl/repl.cpp
    repl/replStates.cpp
    repl/commandline.cpp
    state.cpp
    utils.cpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

add_executable(${PROJECT_NAME} ${sink_cli_SRCS})
target_link_libraries(${PROJECT_NAME} Qt5::Core sink ${XAPIAN_LIBRARIES})
install(TARGETS ${PROJECT_NAME} ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== examples/imapresource/CMakeLists.txt ===
project(sink_resource_imap)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

find_package(KF5 COMPONENTS REQUIRED Mime)
find_package(KIMAP2 0.4 REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

add_library(${PROJECT_NAME} SHARED imapresource.cpp imapserverproxy.cpp)
target_link_libraries(${PROJECT_NAME} sink Qt5::Core Qt5::Network KF5::Mime KIMAP2)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${SINK_RESOURCE_PLUGINS_PATH} RUNTIME DESTINATION ${SINK_RESOURCE_PLUGINS_PATH})

if (WIN32)
    message("Not building imap resource tests on windows")
else()
    add_subdirectory(tests)
endif()

=== examples/webdavcommon/CMakeLists.txt ===
project(sink_webdav_common)

find_package(KPimKDAV2 REQUIRED 0.4)

add_library(${PROJECT_NAME} STATIC webdav.cpp)
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui Qt5::Network KPim::KDAV2 sink)

=== mime/mimetreeparser/CMakeLists.txt ===
set(CMAKE_CXX_VISIBILITY_PRESET default)

find_package(Qt5 COMPONENTS REQUIRED Core Gui)
find_package(KF5Mime 4.87.0 CONFIG REQUIRED)
find_package(KF5Codecs CONFIG REQUIRED)
find_package(Gpgme REQUIRED)

include_directories(${GPGME_INCLUDE_DIRS})
add_library(sink_mimetreeparser STATIC
    objecttreeparser.cpp

    #Bodyformatter
    utils.cpp
    bodypartformatter_impl.cpp

    #Interfaces
    bodypartformatter.cpp

    #bodypartformatter.cpp
    bodypartformatterbasefactory.cpp
    cryptohelper.cpp
    messagepart.cpp
    #Stuff
    mimetreeparser_debug.cpp
    )

target_link_libraries(sink_mimetreeparser
PUBLIC
    KF5::Mime
PRIVATE
    crypto
    KF5::Codecs
    Qt5::Gui
    Gpgme::Gpgme
)

install(FILES
    objecttreeparser.h
    messagepart.h
    partmetadata.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/sink/mimetreeparser COMPONENT Devel
)

add_subdirectory(autotests)
add_subdirectory(tests)

=== examples/imapresource/tests/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../../tests/hawd
    ${CMAKE_CURRENT_BINARY_DIR}/../../../tests/hawd
)

include(SinkTest)

auto_tests (
    imapserverproxytest
    imapmailtest
    imapmailsynctest
)
target_link_libraries(imapserverproxytest sink_resource_imap)
target_link_libraries(imapmailtest sink_resource_imap)
target_link_libraries(imapmailsynctest sink_resource_imap)

manual_tests (
    imapmailsyncbenchmark
    imapmailsyncresponsivenesstest
)
target_link_libraries(imapmailsyncbenchmark sink_resource_imap)
target_link_libraries(imapmailsyncresponsivenesstest sink_resource_imap)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/resetmailbox.sh DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/populatemailbox.sh DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ)

=== mime/mimetreeparser/autotests/CMakeLists.txt ===
include_directories(../)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${GPGME_INCLUDE_DIRS})

set(AUTOMOC ON)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})
add_definitions( -DMAIL_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/../../testdata" )

include(ECMAddTests)
include(${CMAKE_SOURCE_DIR}/cmake/modules/add_gpg_crypto_test.cmake)

macro(add_mimetreeparser_class_unittest _name _additionalSource)
    add_executable(${_name} ${_name}.cpp setupenv.cpp ${_additionalSource})
    target_link_libraries(${_name}
        sink_mimetreeparser
        Qt5::Test
        KF5::Mime
    )
    add_test(NAME ${_name} COMMAND $<TARGET_FILE:${_name}>)
endmacro ()

macro(add_mimetreeparser_crypto_unittest _name)
    add_executable(${_name} ${_name}.cpp setupenv.cpp)
    target_link_libraries(${_name}
        sink_mimetreeparser
        Qt5::Test
        KF5::Mime
        Gpgme::Gpgme
    )
    add_gpg_crypto_test(${_name} mimetreeparser-${_name})
endmacro ()

add_mimetreeparser_crypto_unittest(attachmenttest)
add_mimetreeparser_class_unittest(cryptohelpertest "../cryptohelper.cpp")

=== mime/mimetreeparser/tests/CMakeLists.txt ===
add_subdirectory(gnupg_home)
add_definitions( -DMAIL_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/../../testdata" )
include(${CMAKE_SOURCE_DIR}/cmake/modules/add_gpg_crypto_test.cmake)
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/..
    )
include_directories(${GPGME_INCLUDE_DIRS})

include(ECMAddTests)

add_executable(mimetreeparsertest mimetreeparsertest.cpp)
add_gpg_crypto_test(mimetreeparsertest mimetreeparsertest)
target_link_libraries(mimetreeparsertest
    sink_mimetreeparser
    Qt5::Core
    Qt5::Test
    KF5::Mime
)

add_executable(gpgerrortest gpgerrortest.cpp)
target_link_libraries(gpgerrortest
    sink_mimetreeparser
    Qt5::Core
    Qt5::Test
    KF5::Mime
    Gpgme::Gpgme
)
add_test(NAME gpgerrortest COMMAND $<TARGET_FILE:gpgerrortest>)

=== PKGBUILD ===
# Maintainer: Antonio Rojas <arojas@archlinux.org>

pkgname=sink
pkgver=0.9.0
pkgrel=1
pkgdesc='An offline-caching, synchronization and indexing system for PIM data'
arch=(x86_64)
url='https://community.kde.org/KDE_PIM'
license=(LGPL)
depends=(kcontacts kcalendarcore kasync kimap2 kdav2 lmdb libgit2 xapian-core curl)
makedepends=(extra-cmake-modules flatbuffers git)
#source=(https://download.kde.org/unstable/$pkgname/$pkgver/src/$pkgname-$pkgver.tar.xz)
source=(https://invent.kde.org/pim/$pkgname/-/archive/v$pkgver/$pkgname-v$pkgver.tar.gz)
sha256sums=('b16cf8f7a5f942bf02cdacb4942ef6cb959894ebc4d370ec21be26e948c67349')

prepare() {
  sed -e '/CMAKE_CXX_STANDARD/d' -i $pkgname-v$pkgver/CMakeLists.txt # Fix build
  find -name CMakeLists.txt | xargs sed -e '/add_subdirectory(tests)/d' -i  # Don't build tests 
}

build() {
  cmake -B build -S $pkgname-v$pkgver
  cmake --build build
}

package() {
  DESTDIR="$pkgdir" cmake --install build
}
